// https://www.youtube.com/watch?v=MDvImhzrWr4

fn c<F: FnOnce() + 'static>(f: F) {
    f();
}

fn main() {
    let mut v = vec![1, 2, 3];

    // use move keyword to get around 'static lifetime issue
    c(move || {
        v.push(4);
    }); // without 'static closure lifetime ends here and we have no borrow issue

    // cannot use v after moving the value
    // this is where rc and refcell come into play
    //v.push(5);
    //dbg!(v);
}
