fn c<F: FnOnce() + 'static>(f: F) {
    f();
}

fn main() {
    let v = vec![1, 2, 3];

    c({
        let mut v = v.clone();
        move || {
            println!("inner 1: {:?}", v);
            v.push(4);
        }
    });
    c({
        let mut v = v.clone();
        move || {
            println!("inner 2: {:?}", v);
            v.push(5);
        }
    });

    println!("outer: {:?}", v);
}
